_base_ = [
    '../_base_/models/bisenetv1_r18-d32.py',
    '../_base_/datasets/publicdataset_dresden.py',
    '../_base_/default_runtime.py',
    '../_base_/schedules/schedule_300e_val1_check10.py',
]

norm_cfg = dict(
    type='BN',
)

crop_size = (512, 512)

data_preprocessor = dict(
    size=(512, 512),
    mean=[
        103.172638338208,
        61.44762740851152,
        51.407770213021976,
    ],
    std=[
        75.77031253622098,
        54.63616729031377,
        49.45572239497569,
    ],
    bgr_to_rgb=False,
)

model = dict(
    backbone=dict(
        context_channels=(128, 256, 512),
        norm_cfg=dict(
            type='BN',
        ),
        spatial_channels=(64, 64, 64, 128),
        out_channels=256,
        backbone_cfg=dict(
            type='ResNet',
            norm_cfg=dict(
                type='BN',
            ),
            depth=18,
            init_cfg=dict(
                type='Pretrained',
                checkpoint='./My_Local_Model/open_mmlab/resnet18_v1c.pth',
            ),
        ),
    ),
    data_preprocessor=dict(
        size=(512, 512),
        mean=[
            103.172638338208,
            61.44762740851152,
            51.407770213021976,
        ],
        std=[
            75.77031253622098,
            54.63616729031377,
            49.45572239497569,
        ],
        bgr_to_rgb=False,
    ),
    decode_head=dict(
        type='FCNHead',
        in_channels=256,
        channels=256,
        num_classes=11,
    ),
    auxiliary_head=[
        dict(
            type='FCNHead',
            in_channels=128,
            channels=64,
            num_convs=1,
            num_classes=11,
            in_index=1,
            norm_cfg=dict(
                type='BN',
            ),
            concat_input=False,
            align_corners=False,
            loss_decode=dict(
                type='CrossEntropyLoss',
                use_sigmoid=False,
                loss_weight=1.0,
            ),
        ),
        dict(
            type='FCNHead',
            in_channels=128,
            channels=64,
            num_convs=1,
            num_classes=11,
            in_index=2,
            norm_cfg=dict(
                type='BN',
            ),
            concat_input=False,
            align_corners=False,
            loss_decode=dict(
                type='CrossEntropyLoss',
                use_sigmoid=False,
                loss_weight=1.0,
            ),
        ),
    ],
)

optim_wrapper = dict(
    type='OptimWrapper',
    _delete_=True,
    optimizer=dict(
        type='AdamW',
        lr=0.0001,
        weight_decay=0.0005,
    ),
    clip_grad=dict(
        max_norm=1,
        norm_type=2,
    ),
)

param_scheduler = [
    dict(
        type='LinearLR',
        start_factor=1e-06,
        by_epoch=True,
        begin=0,
        end=10,
    ),
    dict(
        type='PolyLR',
        power=0.9,
        begin=10,
        end=300,
        eta_min=1e-05,
        by_epoch=True,
    ),
]

